#ifndef _3DCASTE_AA
#define _3DCASTE_AA

texture_t screenimage;
#define ANTIALIAS_AMOUNT 0.002


void initAntialias(){
            glGenTextures(1,&screenimage.texID);    
            glBindTexture(GL_TEXTURE_2D,screenimage.texID);
            
            unsigned char* imgData=(unsigned char*)malloc(sizeof(unsigned char)*resx*resy*3);
            glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,resx-1,resy-1,0,GL_RGB,GL_UNSIGNED_BYTE,imgData);
            delete [] imgData;    

            
            glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
            glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
            glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
            glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

}
                
 

void antialias_Scene(){
            
            glBindTexture(GL_TEXTURE_2D,screenimage.texID);
            glCopyTexImage2D(GL_TEXTURE_2D,0,GL_RGB,0,0,resx-1,resy-1,0);          
            
            glMatrixMode(GL_PROJECTION);		// set projection matrix current matrix
			glLoadIdentity();					// reset projection matrix	// calculate aspect ratio of window
			
			glOrtho( 0, resx , resy , 0, -1, 1 );							// Select Ortho Mode (640x480)

			glMatrixMode(GL_MODELVIEW);			// set modelview matrix
			glLoadIdentity();
            
            glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);        // Clear The Screen And The Depth Buffer
            
            //glTranslatef(0.0,0.0,-5.0);
            glBindTex(screenimage);
            
           
            glColor3f(1.0,1.0,1.0);
            
            
            glBegin(GL_QUADS);               
               glTexCoordARB(0,1-(0.5*ANTIALIAS_AMOUNT),0);glVertex2f(0,0);
               glTexCoordARB(0,0,0);glVertex2f(0,resy);
               glTexCoordARB(1-(0.5*ANTIALIAS_AMOUNT),0,0);glVertex2f(resx,resy);
               glTexCoordARB(1-(0.5*ANTIALIAS_AMOUNT),1-(0.5*ANTIALIAS_AMOUNT),0);glVertex2f(resx,0);
            glEnd();
            
            glEnable(GL_BLEND);
            glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
            glDisable(GL_DEPTH_TEST);
            glBegin(GL_QUADS);
               glColor4f(1.0,1.0,1.0,0.5);
               glTexCoordARB((0.5*ANTIALIAS_AMOUNT),1);glVertex2f(0,0);
               glTexCoordARB((0.5*ANTIALIAS_AMOUNT),0);glVertex2f(0,resy);
               glTexCoordARB(1,0);glVertex2f(resx,resy);
               glTexCoordARB(1,1-(0.5*ANTIALIAS_AMOUNT));glVertex2f(resx,0);
               glColor4f(1.0,1.0,1.0,0.5);
               glTexCoordARB(0,1);glVertex2f(0,0);
               glTexCoordARB(0,(0.5*ANTIALIAS_AMOUNT));glVertex2f(0,resy);
               glTexCoordARB(1-(0.5*ANTIALIAS_AMOUNT),(0.5*ANTIALIAS_AMOUNT));glVertex2f(resx,resy);
               glTexCoordARB(1-(0.5*ANTIALIAS_AMOUNT),1);glVertex2f(resx,0);
               glColor4f(1.0,1.0,1.0,0.5);
               glTexCoordARB((0.5*ANTIALIAS_AMOUNT),1); glVertex2f(0,0);
               glTexCoordARB((0.5*ANTIALIAS_AMOUNT),(0.5*ANTIALIAS_AMOUNT)); glVertex2f(0,resy);
               glTexCoordARB(1,(0.5*ANTIALIAS_AMOUNT)); glVertex2f(resx,resy);
               glTexCoordARB(1,1); glVertex2f(resx,0);
            glEnd();
            glDisable(GL_BLEND);
            glUnbindAll();
            glEnable(GL_DEPTH_TEST);
            glMatrixMode(GL_PROJECTION);                        // Select The Projection Matrix
            glLoadIdentity();                                // Reset The Projection Matrix

            // Calculate The Aspect Ratio Of The Window
            gluPerspective(45.0f,(GLfloat)resx/(GLfloat)resy,0.1f,9999999.0f);

            glMatrixMode(GL_MODELVIEW);                        // Select The Modelview Matrix
            glLoadIdentity();                                // Reset The Modelview Matrix
}

#endif


