/*
  Name: logging.h
  Author: Carsten Haubold (CarstenHaubold@web.de)
  Date: 14.02.05 20:39
  Description: Useful procedures to have log or other kinds of output...
               free for everybody to use because it's nothing special (-;
*/

#include <windows.h>
#include <stdio.h>

#ifndef __LOGGING
#define __LOGGING



//***************************************************************
//   error-output with argumentlist, as printf() function has
//***************************************************************
void log_init(const char *title){
    time_t zeit;
    time(&zeit);
    char date[200];
    strftime(date,199,"%A, %d. %B %Y - %X\n",localtime(&zeit));
    FILE *logf;
	logf=fopen("log.txt","wt");
	fprintf(logf,"%s : %s\n\n",title,date);
	fclose(logf);   
};
void log_txt(const char *str, ...){
    char text[512];
	va_list an;
	if(str!=NULL){
        va_start(an,str);
		vsprintf(text,str,an);
		va_end(an);
    }

    
    FILE *logf;
	logf=fopen("log.txt","at");
	fprintf(logf,"%s\n",text);
	fclose(logf);
    

};

void log_msg(const char *str, ...){
    char text[512];
	va_list an;
	if(str!=NULL){
        va_start(an,str);
		vsprintf(text,str,an);
		va_end(an);
    }

    
    FILE *logf;
	logf=fopen("log.txt","at");
	fprintf(logf,"%s\n",text);
	fclose(logf);
    

    ShowCursor(true);
	MessageBox(0,text,"Error occured!!",MB_OK | MB_ICONEXCLAMATION);
	ShowCursor(false);

};

bool log_yn(const char *str, ...){
    char text[512];
	va_list an;
	if(str!=NULL){
        va_start(an,str);
		vsprintf(text,str,an);
		va_end(an);
    }
    
    bool yes;
    ShowCursor(true);
	if(MessageBox(0,text,"Error occured!!",MB_YESNO|MB_ICONEXCLAMATION)==IDYES) yes=true;
	else yes=false;
	ShowCursor(false);
    
    FILE *logf;
	logf=fopen("log.txt","at");
	if(yes) fprintf(logf,"%s : yes\n",text);
	else fprintf(logf,"%s : no\n",text);
	fclose(logf);
    
    
    return yes;

};


#endif

