#ifndef _WATER
#define _WATER

#define STEP 1000

class Water{
      public:
             int height;
             int maxview;
             texture_t tex[6];
      private:
              float frames;
      public:      
             Water(){}
             
             Water(int h, int max){
                      height=h;
                      maxview=max; 
                      frames=0;                      
             } 
             
             void initTex(){
                       tex[0]=LoadTexture(tex[0].name,false);
                       tex[1]=LoadTexture(tex[1].name,false);
                       tex[2]=LoadTexture(tex[2].name,false);
                       tex[3]=LoadTexture(tex[3].name,false);
                       tex[4]=LoadTexture(tex[4].name,false);
                       tex[5]=LoadTexture(tex[5].name,false);          
             }    
             
             void draw(Vertex pos){
                  glBindTex(tex[(int)floor(frames)]);
                  
                  glBegin(GL_QUADS);
                  
                  for(int x=-int(maxview);x<=int(1.5*maxview);x+=STEP){
                         for(int y=-int(maxview);y<=int(1.5*maxview);y+=STEP){
                              glTexVert(0,0,x,height,-y); 
                              glTexVert(1,0,x+STEP,height,-y);  
                              glTexVert(1,1,x+STEP,height,-y+STEP);  
                              glTexVert(0,1,x,height,-y+STEP);            
                         }         
                  }
                  glEnd();
                  
                  frames+=0.25;
                  if(frames>=6) frames=0;
             }
};

#endif