#include "framework/opengl.h"
#include "framework/antialias.h"

//Already defied in Menu.h
//#define GK(x) if(keys[x])
//#define GKT(x) if(!keys[x] && keytemp[x])
//bool keytemp[256];
char fontstr[50],terrastr[50],soundfile[50],logofile[50];
ModelInstance models[MAXMODELS];
int modelnr;

//texture_t ftex; from menu.h
CTimer timer;
int fps;
Vertex pos, viewdir;
Terrain terra;
Camera cam;
double timespan=0;

float fpsq;


Skybox sky;
int actmodel;
bool firstdone=false;
texture_t ftex;
Water wat;


//**********************************************************
//Sets everything to start-pos
//**********************************************************


void InitPositions(){
        log_txt("Initializing Positions...");

        cam.yaw=0;
        cam.yrot=45;
        cam.pos.x=200;
        cam.pos.z=200;
        cam.speed=0;
        cam.pos.y=terra.getIUSHeight(200,200)+10;
        cam.init(cam.pos.x,cam.pos.y,cam.pos.z,0,0,1,terra.scale*(terra.max-2));
        cam.update(1);

        log_txt("Positions initialized!");
}


// All Setup For OpenGL Goes Here

int InitGL(GLvoid)
{

        FILE *config;
        config=fopen("data/settings.txt","rt");

        fscanf(config,"\n[FILES]\n\n");
        fscanf(config,"FONT: %s \n",&fontstr);
        fscanf(config,"LOGO: %s\n",&logofile);
        fscanf(config,"TERRAIN: %s \n",&terrastr);
        char modelfile[50], carfile[50];
        fscanf(config,"MODELPOS: %s\n",&modelfile);
        fscanf(config,"CARFILE: %s\n",&carfile);
        fscanf(config,"SOUND: %s\n",&soundfile);
        initSound();
        playSound(soundfile);
        fscanf(config,"CARSOUND: %s\n",&soundfile);
        //carsnd=load3DSound(soundfile);
        fscanf(config,"SKY: %s\n",&carfile);
        fclose(config);
        MultiTexturing();
        if(multitex) initAntialias();
        timer.Init();
        fps=0;

        terra.init(terrastr);
        wat=Water(terra.hscale*14,terra.max*terra.scale+terra.MaxView);
        sprintf(wat.tex[0].name,"data/levels/caustic_001.bmp");
        sprintf(wat.tex[1].name,"data/levels/caustic_002.bmp");
        sprintf(wat.tex[2].name,"data/levels/caustic_003.bmp");
        sprintf(wat.tex[3].name,"data/levels/caustic_004.bmp");
        sprintf(wat.tex[4].name,"data/levels/caustic_005.bmp");
        sprintf(wat.tex[5].name,"data/levels/caustic_006.bmp");
        wat.initTex();
        sky=Skybox(carfile,terra.MaxView,terra.max*terra.scale,terra.hscale);
        glClearColor(0,0,0,1);
        ftex=LoadTexture(fontstr,false);
        glBuildFont(ftex);
        glEnable(GL_TEXTURE_2D);
        glShadeModel(GL_SMOOTH);
		glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
		//glEnable(GL_POLYGON_SMOOTH);
		cam=Camera();

        modelnr=0;
        log_txt("Loading Modelpositions from %s",modelfile);
        config=fopen(modelfile,"rt");
        fscanf(config,"[MODELS]\nMODELINSTANCENR: %i\n\n",&modelnr);

        for(int x=0;x<modelnr;x++){
                fscanf(config,"NR:%i X:%f Y:%f Z:%f RX:%f RY:%f RZ:%f SC:%f\n",&models[x].parentNR,&models[x].pos.x,&models[x].pos.y,&models[x].pos.z,&models[x].rot.x,&models[x].rot.y,&models[x].rot.z,&models[x].scale);
                models[x].pos.y=terra.getIUSHeight(models[x].pos.x,models[x].pos.z)-30;
                models[x].anim=0;
        }

        InitPositions();
        
        
        initLogo(logofile);


        return TRUE;
                                                                   // Initialization Went OK
}
//**********************************************************
//getKeys for Input handling
//**********************************************************

void getKeys(){
     for(int x=0;x<256;x++) if(keys[x]) keytemp[x]=true;
     //for moving the car



        //Camera movement
        GK(VK_UP) cam.accelerate(0.45*fpsq);
        GK(VK_DOWN) cam.slowdown(0.45*fpsq);


        GK(VK_LEFT) cam.look_left(0.45*fpsq);
    	GK(VK_RIGHT) cam.look_right(0.45*fpsq);
        GK(VK_PRIOR) cam.look_up(0.45*fpsq);
        GK(VK_NEXT) cam.look_down(0.45*fpsq);
        GK(VK_SPACE) cam.stop();


        GKT(VK_END){
                           keytemp[VK_END]=false;
                           log_txt("******************************************+\nReset!\n********************************************");
                           InitPositions();
        }

}//getKeys





//da muss die zeichenscheie rein
int DrawGLScene(GLvoid)                                                // Here's Where We Do All The Drawing
{

        GK(VK_F1){//Helpscreen
                glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);        // Clear The Screen And The Depth Buffer
                glLoadIdentity();
                glPrint(255,0,0, 300,60,"3D-Caste Controls",(int)cam.yrot);
                glPrint(192,192,192,270,100,"Uparrow   -   Forward");
                glPrint(192,192,192,270,140,"Downarrow -   Break/Back");
                glPrint(192,192,192,270,180,"Leftarrow -   Steer/look left");
                glPrint(192,192,192,270,220,"Rightarrow-   Steer/look right");
                glPrint(192,192,192,270,260,"Space     -   Stop");
                glPrint(192,192,192,270,300,"End       -   Reset");
                glPrint(255,255,255,270,380,"ESC       -   Quit");
        }
        else{
        
        getKeys();
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);        // Clear The Screen And The Depth Buffer
        glLoadIdentity();


        fps=(int)timer.GetFPS();
        fpsq=(float)40/(float)fps;



        glViewport(0,0,resx,resy);
        //draw the terrain
        glLoadIdentity();


        
        //if(cam.pos.y>terra.sky.height*250) cam.pos.y=terra.sky.height*250;
                
        cam.update(1);
        if(cam.pos.y<terra.getIUSHeight(cam.pos.x,cam.pos.z)+50) cam.pos.y=terra.getIUSHeight(cam.pos.x,cam.pos.z)+50;
        if(cam.pos.y<(wat.height+30)) cam.pos.y=wat.height+30;
        cam.positionCamera();
            if(!firstdone){//Logo not yet shown
                       
                       showLogoScreen();
                       GK(VK_SPACE){
                                    InitPositions();
                                    firstdone=true;
                       }
            }
            else{
                    //move3DSound(carsnd,carobj.pos.x,carobj.pos.y,carobj.pos.z,carobj.speed,cam.pos, cam.viewdir);
                    //new3DPos();
                    glColor3f(1,1,1);
                    //*****************************************************************
                    //Reflection
                    //*****************************************************************
                    glPushMatrix();
                        double reflectPlane[] = {0.0f, -1.0f, 0.0f, wat.height};//only things below Clipping plane are drawn
                        glEnable(GL_CLIP_PLANE0);							// Turn on clipping for plane 0
                        glClipPlane(GL_CLIP_PLANE0, reflectPlane);          //Set plane as defined in reflectPlane
                        glEnable(GL_BLEND);
                	    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);                     
                        glColor4f(1.0f, 1.0f, 1.0f, 0.7f);
                        glTranslatef(0.0,2*wat.height+5,0.0);                //Translate terrain so it is seen as reflection below the water surface
                        glScalef(1.0,-1.0,1.0);                             //Turn upside down
                        
                        for(int x=0;x<modelnr;x++){
    
                            if(fabs(models[x].pos.x-cam.pos.x)*2<terra.MaxView && fabs(models[x].pos.z-cam.pos.z)*2<terra.MaxView){
                                  models[x].SetModelPos();
                                  terra.models[models[x].parentNR].RenderFrame();//Animate(int(floor(models[x].anim=0)),int(floor(models[x].anim=0))+1,(models[x].anim-int(floor(models[x].anim=0)))*100);
                                  glPopMatrix();
    
                            }
    
                        }
                        
                        terra.renderTerrain(cam.pos);                       //Render terrain
                        sky.draw();
                        glDisable(GL_CLIP_PLANE0);
                    glPopMatrix();
                    
                    
                    glColor4f(1.0f, 1.0f, 1.0f, 0.5f);
          		    wat.draw(cam.pos);
            	        
                    glDisable(GL_BLEND);
                	sky.draw();
                	/*glEnable(GL_STENCIL_TEST);
                	glStencilFunc(GL_ALWAYS,1,1);
                	glStencilOp(GL_KEEP,GL_REPLACE,GL_REPLACE);*/
                    terra.renderTerrain(cam.pos);
                    //wat.draw(cam.pos);
                    //draw the models
                    /*glEnable(GL_BLEND);
                	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);  
                    glColor4f(0.0,0.0,0.0,0.75);
                    for(int x=0;x<modelnr;x++){
    
                            if(fabs(models[x].pos.x-cam.pos.x)*2<terra.MaxView && fabs(models[x].pos.z-cam.pos.z)*2<terra.MaxView){
                                  models[x].SetModelPos();
                                  Vertex v=newV(-200,-200,200);//Set Sun-pos, with swapped coordinates: x=x / y=-z / z=-y
                                  
                                  v.x=v.x*sin(DEG2RAD*models[x].rot.y);
                                  v.z=v.z*cos(DEG2RAD*models[x].rot.y);
                                  v=add(v,models[x].pos);
                                  glStencilFunc(GL_EQUAL,1,2);
                                  glDepthFunc(GL_GEQUAL);
                                  glStencilOp(GL_KEEP,GL_KEEP,GL_INCR);
                                  //glStencilOp(GL_KEEP,GL_INCR,GL_KEEP);
                                  glColorMask(0,0,0,0);
                                  glDepthMask(0);
                                  glDisable(GL_CULL_FACE);
                                  //glCullFace(GL_BACK);                                  
                                  terra.models[models[x].parentNR].RenderShadowedFrame(v);
                                  //glCullFace(GL_BACK);
                                  glDepthMask(1);
                                  glDepthFunc(GL_LESS);
                                  glStencilFunc(GL_EQUAL,2,2);
                                  glStencilOp(GL_KEEP,GL_KEEP,GL_ZERO);
                                  
                                  //glStencilOp(GL_KEEP,GL_DECR,GL_KEEP);
                                  glColorMask(1,1,1,1);
                                  terra.models[models[x].parentNR].RenderShadowedFrame(v);
                          
                                  glPopMatrix();
    
                            }  
    
                    }
                  glDepthFunc(GL_LESS);
                  glDisable(GL_STENCIL_TEST);
                  glDisable(GL_BLEND);
                  glDisable(GL_CULL_FACE);
                  glDepthMask(1);*/
                  glColor3f(1.0,1.0,1.0);                    
                    for(int x=0;x<modelnr;x++){
    
                            if(fabs(models[x].pos.x-cam.pos.x)*2<terra.MaxView && fabs(models[x].pos.z-cam.pos.z)*2<terra.MaxView){
                                  models[x].SetModelPos();
                                  terra.models[models[x].parentNR].RenderFrame();
                                  glPopMatrix();
    
                            }  
    
                    }
    
    
                    if(multitex) antialias_Scene();
                    glLoadIdentity();
    
                    //********************************************************
                    //drawing done, so print everything needed to screen
                    glBindTex(ftex);
    
                    glPrint(255,0,0, 20,20,"FPS: %i   CPU: %i",fps,(int)(100*CPUusage()));
                    glPrint(255,0,0, 20,40,"x: %f  y: %f  z: %f",cam.pos.x, cam.pos.y,cam.pos.z);
                    glPrint(255,0,0, 20,60,"yrot: %i",(int)cam.yrot);
                    //glPrint(0,0,0,0,0,"");
                    
                    
            }//else firstdone
        }//else GK(VK_F1)
        glFlush();
        return TRUE;                                                            // Keep Going
}
